module type Type = sig

type t = string
external length : string -> int = "%string_length"
external get : string -> int -> char = "%string_safe_get"
external set : string -> int -> char -> unit = "%string_safe_set"
val create : int -> string
val make : int -> char -> string
val copy : string -> string
val sub : string -> int -> int -> string
val fill : string -> int -> int -> char -> unit
val blit : string -> int -> string -> int -> int -> unit
val concat : string -> string list -> string
val iter : (char -> unit) -> string -> unit
val escaped : string -> string
val index : string -> char -> int
val rindex : string -> char -> int
val index_from : string -> int -> char -> int
val rindex_from : string -> int -> char -> int
val contains : string -> char -> bool
val contains_from : string -> int -> char -> bool
val rcontains_from : string -> int -> char -> bool
val uppercase : ?locale:string -> string -> string
val lowercase : ?locale:string -> string -> string
val titlecase : ?locale:string -> string -> string
val capitalize : ?locale:string -> string -> string
val uncapitalize : ?locale:string -> string -> string
val nfd : string -> string
val nfc : string -> string
val nfkd : string -> string
val nfkc : string  -> string
val compare: t -> t -> int
val compare_col : 
    ?locale:string 
  -> ?strength:int
    -> ?variable:
	[ `Blanked | `Non_ignorable | `Shifted | `Shift_Trimmed ]
      -> string -> string -> int
val search_col :
    ?locale:string
  -> ?strength:int 
    -> ?variable: 
	[ `Blanked | `Non_ignorable | `Shifted | `Shift_Trimmed ]
      -> string -> string -> int -> int * int

external unsafe_get : string -> int -> char = "%string_unsafe_get"
external unsafe_set : string -> int -> char -> unit = "%string_unsafe_set"
end
